package simpleJPA.view;

import java.io.*;
import java.util.Random;

import simpleJPA.model.*;
import simpleJPA.controller.*;

/**
 * 
 * This class allows a user to input client and/or participant data.
 * The data is then persisted and can be viewed by running ListClients_JSP.
 *
 */

public class InputClientForm_JSP {

	
	
	public static void main(String[] args) {
		
		AddClient ac = new AddClient();
		ListClients lc = new ListClients();
	    Client client=new Client();
	    
	    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	    String which = "1";

	    System.out.println("Are you working on Part 2, 3, or 4?: ");

	      try {
	         which=br.readLine();
	      } catch (IOException ioe) {
	         System.out.println("IO error trying to read your [2/3/4] response.");
	         System.exit(1);
	      }
	    
	      if(which.trim().equalsIgnoreCase("2")){

	    	  System.out.println("Enter company name: ");
		
			      try {
			         client.setName(br.readLine());
			      } catch (IOException ioe) {
			         System.out.println("IO error trying to read client's name.");
			         System.exit(1);
			      }
		
			    System.out.println("Enter industry type: ");
			   
			      try {
			         client.setIndustry(br.readLine());
			      } catch (IOException ioe) {
			         System.out.println("IO error trying to read industry type.");
			         System.exit(1);
			      }
		
			    System.out.println("Enter location: ");
				   
			      try {
			         client.setHeadquarterLocation(br.readLine());
			      } catch (IOException ioe) {
			         System.out.println("IO error trying to read location.");
			         System.exit(1);
			      }		      
			      
				     ac.setClient(client);					  
				     String retValue = ac.execute();
				     
				     if(retValue.equalsIgnoreCase("SUCCESS") ){
				    	 System.out.println("Thank you, your client information has been successfully entered!");		    	 
				     }else
				    	 System.out.println("A problem occurred while attempting to persist your client data.");
	      }//end if #1
	      else if (which.trim().equalsIgnoreCase("3")){
	    	    String LCretValue = lc.execute();
	    	    Client clients [] = lc.getClients();
	    	    int numClients = clients.length;
	    	    
	    	    for(int i=0; i<numClients; i++){
	    	    	client=clients[i];
		    	    Employee p=new Employee();
  	  
			    System.out.println("Enter an employee name for "+client.getName()+": ");
				
			      try {
			         p.setEmployeeName(br.readLine());
			      } catch (IOException ioe) {
			         System.out.println("IO error trying to read employee's name.");
			         System.exit(1);
			      }
		
			    System.out.println("Enter a position title: ");
			   
			      try {
			         p.setPosition(br.readLine());
			      } catch (IOException ioe) {
			         System.out.println("IO error trying to read position title.");
			         System.exit(1);
			      }
			      
			     client.setEmployee(p);
			     ac.setUpdate(true);
			     ac.setClient(client);					  
			     String retValue = ac.execute();
			     
			     if(retValue.equalsIgnoreCase("SUCCESS") ){
			    	 System.out.println("Thank you, your client information has been successfully entered!");		    	 
			     }else
			    	 System.out.println("A problem occurred while attempting to persist your client data.");
			     
	    	    }//end for clients
	    	  
	      }// end if #2
	      else if (which.trim().equalsIgnoreCase("4")) {
    	        System.out.println("Populating multiple participants for each client...");	    	     
	    	    String LCretValue = lc.execute();
	    	    Client clients [] = lc.getClients();
	    	    int numClients = clients.length;
	    	    String retValue = "Working";
	    	    String [] fname = {"Scott","Jim","Mickey","Roger","Dave","Philippa","Lauren","Theresa","Beth","Patrick", "Cassandra"};
	    	    String [] lname = {"Johnson", "Smith", "Jacobs", "Adams", "Lewis", "Scott","Williams", "Harris"};
	    	    
	    	    for(int i=0; i<numClients; i++){
	    	    	client=clients[i];
	    	    	int numP=4;
	    	    	Employee p;
	    	    	
	    	    	for(int j=0; j<numP; j++){
			    	    p=new Employee();
			    	    //make the names more interesting by using the name arrays above
			    	    Random pickName = new Random();
			    	    int findex = pickName.nextInt(11);
			    	    int lindex = pickName.nextInt(8);  
			    
	  	  				p.setEmployeeName(fname[findex]+" "+lname[lindex]);
	  	  				p.setPosition("Software Engineer");    	     
	  	  				client.addEmployee(p);
	    	    	}
			        ac.setUpdateMany(true);
			        ac.setClient(client);					  
			        retValue = ac.execute();
	    	    }
			     
			     if(retValue.equalsIgnoreCase("SUCCESS") ){
			    	 System.out.println("The information has been successfully added!");		    	 
			     }else
			    	 System.out.println("A problem occurred while attempting to persist the participant data.");
	    	  
	    	  
	      }//end if #3
	      else{
	    	System.out.println("Please run again and specify '1', '2', or '3'.  Thank you!");  
	      }
		   
	}

}
