package simpleJPA.view;

import java.lang.*;
import java.lang.reflect.Field;
import java.util.Set;

import simpleJPA.controller.ListClients;
import simpleJPA.model.*;
/**
 * 
 * This class outputs a list of clients and employees, if they exist.  
 *
 */
public class ListClients_JSP {

	public static void main(String[] args) throws ClassNotFoundException {
		
		ListClients lc = new ListClients();
		String retValue = lc.execute();
		

		if(retValue.equalsIgnoreCase("success") ){
				
			Client [] clients = lc.getClients();
			int numClients = clients.length;
			
			System.out.println("Your query returned "+numClients+" results.");
			System.out.println();
			
			for(int i=0; i<numClients; i++){			
				System.out.println(clients[i].getName()+", a "+clients[i].getIndustry() +
						" company, is located in "+clients[i].getHeadquarterLocation() +".");
								
				Employee p=clients[i].getEmployee();
				Set<Employee> pSet= clients[i].getEmployees();
				
				if(p!=null && p.getEmployeeName()!=null){				
					//For 1:1 relationship
					System.out.println("\t The following employee is CEP participant: ");
					System.out.println("\t \t"+ p.getEmployeeName()+", "+p.getPosition());
				}
			
				if(pSet.size()>0){
					//For 1:n relationship
					Object [] pArr =  pSet.toArray();
					int numParts = pArr.length;
					System.out.println("\t The following "+numParts+" employees are CEP participants: ");
					//Employee p;
					for(int j=0; j<numParts; j++){
						p= (Employee) pArr[j];
						System.out.println("\t \t"+ p.getEmployeeName()+", "+p.getPosition());						
					}
				}				
				System.out.println();
			}				
		}else{
			System.out.println("A problem occurred while attempting to retrieve your client data.");
		}
	}
 
}
