package simpleJPA.model;

import java.sql.*;
import simpleJPA.*;
import java.util.LinkedHashMap;
import java.util.LinkedList;

/**
 * 
 * The DB_Accessor class contains methods to access, update, and query the 
 * database containing survey information.  Important database parameters are
 * specified in CONSTANTS.java.
 * 
 * 
 */

public class DB_Accessor {

  static Statement stmt;
  static Connection conn;
  static CONSTANTS c = new CONSTANTS();

  
  /**
   * Inserts a row into the <code>client</code> table.
   *   
   * @param client - a Client class containing values for each field
   */
  public void insertClient(Client client){
	  
      String insert ="INSERT INTO Client (" +
      		"ID, name, headquarterLocation, industry) VALUES("+client.getID_int()+", '" +
    	  client.getName()+"', '"+client.getHeadquarterLocation()+"', '"+client.getIndustry()+"')" ;
            
      doInsert(insert);
   
  }//end insertClient
  
  /**
   * Retrieves data from the <code>getClients</code> table.
   * 
   * @param by - the table field used for the query
   * @param value - the value by which to query
   * @return a Client array
   */
  public Client [] getClients(){
	  return getClients("ALL", "ALL");
	  
  }
  
  /**
   * Retrieves data from the <code>getClients</code> table.
   * 
   * @param by - the table field used for the query
   * @param value - the value by which to query
   * @return a Client array
   */
  public Client [] getClients(String by, String value){
		
	    String query = "SELECT * FROM Client WHERE "+by+"='"+value+"'";
	  	
	    if(by.equalsIgnoreCase("all")&& value.equalsIgnoreCase("all") )
	  		query = "SELECT * FROM Client";
	  	
	    LinkedList list = doQuery(query);	    
	    int size = list.size()-1;
	    Client [] cArr = new Client[size];
	    
	    for(int i=0; i<size; i++){
	      cArr[i] = new Client();
	      String[] item = (String[]) list.get(i+1);    			   
	      cArr[i].setID(item[0]);
	      cArr[i].setName(item[1]);
	      cArr[i].setIndustry(item[3]);
	      cArr[i].setHeadquarterLocation(item[2]);

	    }//end for i	    
	    
	    return cArr;
  }//end getClients

  public void updateClientEmployee(Client client) {
		// N/A for Task 1 - JDBC
		
	}

	public void updateClientEmployees(Client client) {
		// N/A for Task 1 - JDBC
		
	}

  /**
  * Connects to the database specified in CONSTANTS.java, 
  * performs the query and parses the results
  * to return a linked list of String [].  The first item is the list of
  * column names, and the rest are the results for each of the columns.
  * 
  * @param query - the string to query the database. For example, "SELECT * FROM questions".
  */
  public LinkedList doQuery(String query){

    LinkedList results = new LinkedList();

    try {
      java.lang.Class.forName(c.DRIVER).newInstance();
    } catch (Exception E) {
       System.err.println("Unable to load driver.");
       E.printStackTrace();
     }

    try {
      conn = DriverManager.getConnection(c.DB_CONNECTION);     
      stmt = conn.createStatement();
      ResultSet RS = stmt.executeQuery(query);

     ResultSetMetaData metaData = RS.getMetaData();

      int numCols = metaData.getColumnCount();
     // Print the column headers
      
     String [] colNames = new String[numCols];
      for (int i=1; i<=numCols; i++) {
         colNames[i-1]=metaData.getColumnLabel(i);
      }
      results.add(colNames);

      // Now the data
      while (RS.next()) {
        String [] oneResult = new String[numCols];
         for (int i=1; i<=numCols; i++) {
           oneResult[i-1]=RS.getString(i);
         }
         results.add(oneResult);
      }//end while rs.next

      RS.close();
      stmt.close();
      conn.close();

   } catch (SQLException E) {
      System.out.println("SQLException: " + E.getMessage());
      //System.out.println("SQLState:     " + E.getSQLState());
      //System.out.println("VendorError:  " + E.getErrorCode());
  }
    return results;

}//end doquery

  /**
   * Performs insert and delete actions.
   * 
   * @param insert - the insert statement, can also be a delete statement
   */
public void doInsert(String insert){
  try {
   java.lang.Class.forName(c.DRIVER).newInstance();
  }

  catch (Exception E) {
      System.err.println("Unable to load driver.");
      E.printStackTrace();
  }

   try{
    conn = DriverManager.getConnection(c.DB_CONNECTION);
    stmt = conn.createStatement();
    stmt.executeUpdate(insert);
    stmt.close();
    conn.close();

   }catch (SQLException E) {
      System.out.println("SQLException: " + E.getMessage());
      //System.out.println("SQLState:     " + E.getSQLState());
      //System.out.println("VendorError:  " + E.getErrorCode());
   }
 }//end doInsert

 public static void main(String [] args){
  
   DB_Accessor dba=new DB_Accessor();
   
   //test getClients()
   //dba.getClients();
 
   /*
   int size = 10;
   Client client;

   for(int i=12; i<size+12; i++){
     client = new Client();
     String[] item = {"auto", "name","ind","hqtr"};  			   
     client.setID(i);
     client.setName(item[1]+i);
     client.setIndustry(item[2]+i);
     client.setHeadquarterLocation(item[3]+i);
     
     dba.insertClient(client);
   }//end for i	  
   */
   
   
   
 }//end main



}//end class